#include "stdafx.h"
#include "NeMessenger.h"
#include "ChatSendMsgThread.h"
#include "ChatDlg.h"


IMPLEMENT_DYNCREATE(CChatSendMsgThread, CWinThread)

CChatSendMsgThread::CChatSendMsgThread()
	: m_pChatDlg(NULL),
	m_bRunThread(TRUE),
	m_bSendRemainMsgOnTerminate(FALSE)
{
}

CChatSendMsgThread::~CChatSendMsgThread()
{
    m_pChatDlg = NULL;
}

BOOL CChatSendMsgThread::InitInstance()
{
	return TRUE;
}

int CChatSendMsgThread::ExitInstance()
{
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CChatSendMsgThread, CWinThread)
END_MESSAGE_MAP()


int CChatSendMsgThread::Run()
{
    P_SEND_CHAT_MESSAGE pChatMessage = NULL;
    BOOL bStoped = FALSE;

    GET_CONFIG()->GetStickerMgr().Load();	//load sticker

    while( m_bRunThread )
	{
		//Sleep(1000);
		if( m_bRunThread == FALSE )
			break;

		if( m_pChatDlg == NULL )
			continue;

        if (NULL == pChatMessage)
        {
            pChatMessage = m_pChatDlg->GetChatMsgFromQueue(&bStoped);
            if (bStoped)
            {
                m_bRunThread = FALSE; //user stop -- then need quit to avoid busy loop
            }
        }

		if( pChatMessage == NULL )
			continue;

		if(m_pChatDlg->InitChatRoom() == FALSE)
		{
            NTALK_LOG->Error(L"[CHAT]CChatSendMsgThread call InitChatRoom Fail");

			//m_pChatDlg->RemoveChatMsgFromQueue();
			m_pChatDlg->DisplayNetworkErrorMessage();
			continue;
		}

		if( m_pChatDlg->InviteChatUser() == FALSE )
		{
            NTALK_LOG->Error(L"[CHAT] CChatSendMsgThread call InviteChatUser Fail");
			//m_pChatDlg->RemoveChatMsgFromQueue();
			continue;
		}

		BOOL bResult = FALSE;
		if (m_pChatDlg->m_pNtalk)
		{
#ifdef _DEBUG
            NTALK_LOG->Debug(L"[CHAT] REQUESTSENDCHATMSG, %d:%d:%d:%d:%s",
                m_pChatDlg->GetRoomID(), pChatMessage->nMsgSeq, pChatMessage->nTid, pChatMessage->msgType, pChatMessage->strMsg);
#else 
            NTALK_LOG->Debug(L"[CHAT] REQUESTSENDCHATMSG, %d:%d:%d:%d",
                m_pChatDlg->GetRoomID(), pChatMessage->nMsgSeq, pChatMessage->nTid, pChatMessage->msgType);
#endif 

			bResult = m_pChatDlg->m_pNtalk->RequestSendChatMsg(pChatMessage->strMsg, &pChatMessage->cfFontStyle, 
                pChatMessage->nTid, pChatMessage->nMsgSeq, pChatMessage->msgType);
		}

		if (FALSE == bResult)
		{
			m_pChatDlg->DisplayNetworkErrorMessage();
			m_pChatDlg->RecoveryServerSession();
		}

        delete pChatMessage;
        pChatMessage = NULL;
		//m_pChatDlg->RemoveChatMsgFromQueue();
	}

	return CWinThread::Run();
}

void CChatSendMsgThread::SetChatDlg(CChatDlg *pDlg)
{
	m_pChatDlg = pDlg;
}

void CChatSendMsgThread::CloseThread(BOOL bSendRemainMsg)
{
	m_bRunThread = FALSE;
	m_bSendRemainMsgOnTerminate = bSendRemainMsg;
}